;**********************************************************************
;    Filename:	level.asm 
;    Date:          	2004/11/6
;    File Version:
;**********************************************************************

	list      		p=16F88			 ; list directive to define processor
	#include		 <p16F88.inc>		 ; processor specific variable definitions

	__CONFIG   _CONFIG1,  _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_IO & _LVP_OFF 

;***** VARIABLE DEFINITIONS
w_temp			EQU     0x20			 ; variable used for context saving 
status_temp		EQU     0x21			 ; variable used for context saving

wait_data		EQU	0x30		;wait data ram
taihi			EQU	0x31		;taihi data
out_data_r		EQU	0x32		;out data r-ch
out_data_l		EQU	0x33		;out data l-ch
out_data_rh		EQU	0x34		;out data r-ch (hight)
out_data_lh		EQU	0x35		;out data l-ch (hight)
in_data_r			EQU	0x36		;in data r-ch
in_data_l			EQU	0x37		;in data l-ch
sagyou			EQU	0x38		;sagyou
wait_data_2		EQU	0x39		;wait data 2
key_data			EQU	0x3a		;key data ram
									;key_data,0  push key	
key_input		EQU	0x3b		;key input ram
									;key_input,0  push key
disp_mode		EQU	0x3c		;disp_mode
									;(0)BAR mode
									;(1)DOT mode

tm0_setdata		EQU	0x63		;FFH-63H=156 156*128=19.968msec

;**********************************************************************
		ORG     		0x000             ; processor reset vector
  		goto    		main              ; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     		0x004             ; interrupt vector location
		movwf   	w_temp            ; save off current W register contents
		movf		STATUS,w          ; move status register into W register
		movwf		status_temp       ; save off contents of STATUS register

		;---------------------------------	
		bcf			INTCON,TMR0IF
		movlw		tm0_setdata
		movwf		TMR0


next_int
		movf    		status_temp,w     ; retrieve copy of STATUS register
		movwf		STATUS            ; restore pre-isr STATUS register contents
		swapf   		w_temp,f
		swapf  		 w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
;---------------------------------------------------------------------------------------
main
		call			osc_set
		call			port_set
		call			ad_set
		
		movlw		0ffh
		movwf		PORTA
		movlw		0ffh
		movwf		PORTB

		call			timer0_set

		movlw		0ffh
		movwf		out_data_r
		movwf		out_data_l
		movwf		out_data_rh
		movwf		out_data_lh
		movwf		in_data_r
		movwf		in_data_l
		
		movlw		00h
		movwf		disp_mode
;--------------------------------------
main_loop
		movlw		0ffh				;key input clear
		movwf		key_input
		btfss		PORTA,4		;push key check
		bcf			key_input,0		;push key input ari
		;--------------------------------- LED disp
		movf		out_data_r,0
		movwf		PORTB
		movf		out_data_rh,0
		movwf		PORTA
		bcf			PORTA,2
		call			wait_10
		bsf			PORTA,2
		
		movf		out_data_l,0
		movwf		PORTB
		movf		out_data_lh,0
		movwf		PORTA
		bcf			PORTA,3
		call			wait_10
		bsf			PORTA,3
		;--------------------------------- CH0 AD start
		movlw		41h
		movwf		ADCON0
		call			wait_20
		call			wait_20
		bsf			ADCON0,2
ch0_wait
		btfsc		ADCON0,2
		goto		ch0_wait
		movf		ADRESH,0
		movwf		in_data_r
		;--------------------------------- CH1 AD start
		movlw		49h
		movwf		ADCON0
		call			wait_20
		call			wait_20
		bsf			ADCON0,2
ch1_wait
		btfsc		ADCON0,2
		goto		ch1_wait
		movf		ADRESH,0
		movwf		in_data_l
		;----------------------------------CH0 henkan
		movf		in_data_r,0
		movwf		sagyou
		movf		sagyou,0
		call			henkan1
		movwf		out_data_r
		movf		sagyou,0
		call			henkan2
		movwf		out_data_rh
		;----------------------------------CH1 henkan
		movf		in_data_l,0
		movwf		sagyou
		movf		sagyou,0
		call			henkan1
		movwf		out_data_l
		movf		sagyou,0
		call			henkan2
		movwf		out_data_lh		
		;----------------------------------push key check
		btfss		PORTA,4		;push key check
		goto		push_next
		bsf			key_data,0		;push key off
		goto		push_end
push_next
		btfsc		key_input,0		;push key input check
		goto		push_end
		btfss		key_data,0		;push key on check
		goto		push_end
		bcf			key_data,0		;push key on
		btfsc		disp_mode,0
		goto		push_next_2
		bsf			disp_mode,0
		goto		push_end
push_next_2
		bcf			disp_mode,0
push_end
	
;---------------------------------------
		goto		main_loop
;-------------------------------------------------------------------------------
wait_20
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;-------------------------------------------------------------------------------
wait_10
		movlw		5h
		movwf		wait_data_2
wait_10_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_10_2
		return

wait_0
		movlw		0ffh
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;------------------------------------------------------------------------------
henkan1
		btfsc		disp_mode,0
		goto		henkan3
		movwf		taihi
		movlw		low(henkan1_table)
		addwf		taihi,1
		movlw		high(henkan1_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan1_table	;-----------
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0feh
		retlw		0feh
		retlw		0feh
		retlw		0feh
		retlw		0fch
		retlw		0fch
		retlw		0fch
		;---------------10		
		retlw		0fch
		retlw		0fch
		retlw		0fch
		retlw		0fch
		retlw		0f8h
		retlw		0f8h
		retlw		0f8h
		retlw		0f8h
		retlw		0f8h
		retlw		0f8h
		retlw		0f8h
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		;---------------20
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		retlw		0f0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		;---------------30
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0e0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		;---------------40
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		0c0h
		retlw		080h
		;---------------50
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		;---------------60
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		080h
		retlw		00h
		;---------------70
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------80
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------90
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------A0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------B0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------C0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------D0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------E0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------F0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h

;-------------------------------------------------------------------------------
henkan2
		btfsc		disp_mode,0
		goto		henkan4
		movwf		taihi
		movlw		low(henkan2_table)
		addwf		taihi,1
		movlw		high(henkan2_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan2_table	;-----------
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------10		
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------20
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------30
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------40
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------50
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------60
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------70
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------80
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------90
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0bfh
		retlw		0bfh
		;--------------A0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;--------------B0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;--------------C0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;--------------D0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		03fh
		;--------------E0
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		;--------------F0
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh
		retlw		03fh

;------------------------------------------------------------------------------
henkan3
		movwf		taihi
		movlw		low(henkan3_table)
		addwf		taihi,1
		movlw		high(henkan3_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan3_table	;-----------
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0feh
		retlw		0feh
		retlw		0feh
		retlw		0feh
		retlw		0fdh
		retlw		0fdh
		retlw		0fdh
		;---------------10		
		retlw		0fdh
		retlw		0fdh
		retlw		0fdh
		retlw		0fdh
		retlw		0fbh
		retlw		0fbh
		retlw		0fbh
		retlw		0fbh
		retlw		0fbh
		retlw		0fbh
		retlw		0fbh
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		;---------------20
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		retlw		0f7h
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		;---------------30
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0efh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		;---------------40
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0dfh
		retlw		0bfh
		;---------------50
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;---------------60
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		07fh
		;---------------70
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		;---------------80
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		;--------------90
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		0ffh
		retlw		0ffh
		;--------------A0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------B0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------C0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------D0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------E0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------F0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh

;-------------------------------------------------------------------------------
henkan4
		movwf		taihi
		movlw		low(henkan4_table)
		addwf		taihi,1
		movlw		high(henkan4_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan4_table	;-----------
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------10		
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------20
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------30
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------40
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------50
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------60
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------70
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------80
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------90
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0bfh
		retlw		0bfh
		;--------------A0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;--------------B0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;--------------C0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		;--------------D0
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		0bfh
		retlw		07fh
		;--------------E0
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		;--------------F0
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
		retlw		07fh
;------------------------------------------------------------------------------
osc_set
		bsf			STATUS,RP0
								;(0)NC
								;(110)IRCF2-IRCF0
								;(0)OSTS
								;(1)IOFS
								;(00)SCS
		movlw		64h
		movwf		OSCCON
		bcf			STATUS,RP0
		return
;-------------------------------------------------------------------------------
port_set							;RA0,RA1,RA4(IN)
								;RA2,RA3,RA6,RA7(OUT)
								;RB0,RB1,RB2,RB3,RB4,RB5,RB6,RA7(OUT)
		bsf			STATUS,RP0
		clrf			TRISA
		bsf			TRISA,0
		nop
		bsf			TRISA,1
		nop
		bsf			TRISA,4
		nop
		clrf			TRISB
		bcf			STATUS,RP0
		return
;------------------------------------------------------------------------------
ad_set
								;(01)ADCS1,ADCS0
								;(000)CHS2,CHS1,CHS0
								;(0)GO/DONE
								;(0)NC
								;(1)ADON
		movlw		41h
		movwf		ADCON0
		bsf			STATUS,RP0
								;(0)ADFM
								;(1)ADCS2
								;(00)VCFG1,VCFG0
								;(0000)
		movlw		040h
		movwf		ADCON1
								;(0)NC
								;(0000011)ANS6-ANS0
		movlw		03h
		movwf		ANSEL
		bcf			STATUS,RP0
		return
;------------------------------------------------------------------------------
timer0_set

		bsf			STATUS,RP0
		movlw		086h		;(1)PORTB NOT PULLUP
								;(0)INTEDG
								;(0)TOCS
								;(0)TOSE
								;(0)PSA
								;(110)1/128
		movwf		OPTION_REG
		bcf			STATUS,RP0

		movlw		tm0_setdata
		movwf		TMR0
		bcf			INTCON,TMR0IE
		bcf			INTCON,GIE
		return
;-------------------------------------------------------------------------------

		end                     ; directive 'end of program'
